"use strict";

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
Cu.import("resource://gre/modules/XPCOMUtils.jsm");
XPCOMUtils.importRelative(this, "base/arPathUtil.jsm");

let EXPORTED_SYMBOLS = ["UnMHTCSSUtil"];

/**
 * CSS ユーティリティ
 */
let UnMHTCSSUtil = {
  /**
   * CSS の import 対象を収集する
   *
   * @param   {string} content
   *          CSS の内容
   * @param   {string} baseDir
   *          CSS の記述されたファイルの親ディレクトリ
   * @returns {Array.<string>}
   *          収集した URL
   */
  gatherImport: function(content, baseDir) {
    let urls = [];
    
    content
      .replace(/(@import\s*(?:url\s*\(\s*)?)(?:\"((?:\\\"|[^\"])+)\"|\'((?:\\\'|[^\'])+)\'|([^\"\';\(\)]+))/ig,
               function(matched, prev, dqpath, qpath, path) {
                 if (dqpath) {
                   path = dqpath.replace(/\\\"/g, "\"");
                 } else if (qpath) {
                   path = qpath.replace(/\\\'/g, "\'");
                 }
                 
                 path = path.replace(/ +$/, "");
                 
                 urls.push(arPathUtil.resolve(baseDir, path));
               });
    
    return urls;
  }
};
