"use strict";

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
Cu.import("resource://gre/modules/XPCOMUtils.jsm");
XPCOMUtils.importRelative(this, "base/arDialog.jsm");
XPCOMUtils.importRelative(this, "base/arPrototype.jsm");

let EXPORTED_SYMBOLS = ["UnMHTFailedListDialogClass"];

/**
 * 保存失敗リストダイアログ
 *
 * ウィンドウの引数
 * {
 *   failedList: {Array.<string>}
 *               保存失敗した URI リスト (必須)
 * }
 *
 * @param   {nsIDOMWindow} window
 *          対象のウィンドウ
 * @extends    arDialog
 * @implements arIDialog
 */
function UnMHTFailedListDialogClass(window) {
  arDialog.call(this, window);
}
UnMHTFailedListDialogClass.prototype = {
  /* ==== arIDialog インターフェース ==== */
  
  /**
   * ロードイベント
   */
  onLoad: function() {
    let arg = this._window.arguments[0];
    let dialog = this.el("unmht_failed_list");
    
    dialog.getButton("accept").focus();
    this.el("failed").value = arg.failedList.join("\n");
  }
};
arPrototype.extend(UnMHTFailedListDialogClass, arDialog);
