"use strict";

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
Cu.import("resource://gre/modules/XPCOMUtils.jsm");
XPCOMUtils.importRelative(this, "base/arArrayUtil.jsm");

let EXPORTED_SYMBOLS = ["UnMHTPseudoID"];

/**
 * そこそこ一意な ID 生成器
 */
let UnMHTPseudoID = {
  /**
   * そこそこ一意な ID を生成する
   *
   * @returns {string}
   *          そこそこ一意な ID
   */
  gen: function() {
    let id
      = this._count.toString(16) + "."
      + this.randHex()
      + "." + Date.now().toString(16);
    this._count = (this._count + 1) % 0xffffffff;
    
    return id;
  },
  
  /**
   * 8 ケタのランダムな 16 進文字列を返す
   *
   * @returns {string}
   *          8 ケタのランダムな 16 進文字列
   */
  randHex: function() {
    return ("0000000" + Math.floor(Math.random() * 0xffffffff).toString(16)).slice(-8);
  },
  
  /* ==== private ==== */
  
  _count: 0, /** 内部カウンタ
              *  @type {number} */
};
