"use strict";

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
Cu.import("resource://gre/modules/Services.jsm");

let EXPORTED_SYMBOLS = ["arAppInfo"];

/**
 * アプリケーション情報
 */
let arAppInfo = {
  /**
   * Firefox かどうか
   * @type {boolean}
   */
  get isFirefox() this._isFirefox,
  
  /**
   * Thunderbird かどうか
   * @type {boolean}
   */
  get isThunderbird() this._isThunderbird,
  
  /**
   * SeaMonkey かどうか
   * @type {boolean}
   */
  get isSeaMonkey() this._isSeaMonkey,
  
  /* ==== private ==== */
  
  _isFirefox: false,     /** Firefox かどうか
                          *  @type {boolean} */
  _isThunderbird: false, /** Thunderbird かどうか
                          *  @type {boolean} */
  _isSeaMonkey: false,   /** SeaMonkey かどうか
                          *  @type {boolean} */
  
  /**
   * 初期化処理
   */
  init: function() {
    let id = "";
    
    try {
      id = Services.appinfo.ID;
    } catch (e) {
      Cu.reportError("Failed to get Application ID\n"
                     + e + "\n" + e.stack);
      return;
    }
    
    switch (id) {
      case "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}": {
        this._isFirefox = true;
        break;
      }
      case "{3550f703-e582-4d05-9a08-453d09bdfdc6}": {
        this._isThunderbird = true;
        break;
      }
      case "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}": {
        this._isSeaMonkey = true;
        break;
      }
    }
  }
};
arAppInfo.init();
