"use strict";

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
Cu.import("resource://gre/modules/XPCOMUtils.jsm");

let EXPORTED_SYMBOLS = ["arDialog"];

/**
 * ダイアログ
 *
 * @param   {nsIDOMWindow} window
 *          対象のウィンドウ
 * @implements arIDialog
 */
function arDialog(window) {
  this._window = window;
}
arDialog.prototype = {
  /* ==== arIDialog インターフェース ==== */
  
  /**
   * 破棄
   */
  destruct: function() {
    this._window = null;
  },
  
  /**
   * ロードイベント
   */
  onLoad: function() {
  },
  
  /**
   * アンロードイベント
   */
  onUnload: function() {
  },
  
  /**
   * ダイアログを OK したイベント
   *
   * @returns {boolean}
   *          ダイアログを閉じるか
   */
  onDialogAccept: function() {
    return true;
  },
  
  /**
   * ダイアログをキャンセルしたイベント
   *
   * @returns {boolean}
   *          ダイアログを閉じるか
   */
  onDialogCancel: function() {
    return true;
  },
  
  /* ==== private ==== */
  
  _window: null,   /** 対象のウィンドウ
                    *  @type {nsIDOMWindow} */
  
  /**
   * getElementById の省略
   *
   * @param   {string} id
   *          要素の ID
   * @returns {nsIDOMElement}
   *          id に対応する要素
   *          見付からなければ null
   */
  el: function(id) {
    return this._window.document.getElementById(id);
  }
};
