"use strict";

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;

let EXPORTED_SYMBOLS = ["arPrototype"];

/**
 * プロトタイプの継承を簡略化する
 */
let arPrototype = {
  /**
   * 継承したプロトタイプを作成する
   *
   * @param   {Function} child
   *          子
   * @param   {Function} parent
   *          親
   */
  extend: function(child, parent) {
    let prop = {};
    for (let name of Object.getOwnPropertyNames(child.prototype)) {
      prop[name] = Object.getOwnPropertyDescriptor(child.prototype, name);
    }
    child.prototype = Object.create(new parent, prop);
  }
};
