"use strict";

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
Cu.import("resource://gre/modules/XPCOMUtils.jsm");

let EXPORTED_SYMBOLS = ["arWindowHook"];

/**
 * ウィンドウフック
 *
 * @param   {nsIDOMWindow} window
 *          対象のウィンドウ
 * @implements arIWindowHook
 */
function arWindowHook(window) {
  this._window = window;
}
arWindowHook.prototype = {
  /* ==== arIWindowHook インターフェース ==== */
  
  /**
   * 破棄
   */
  destruct: function() {
    this._window = null;
  },
  
  /**
   * ウィンドウにロードする
   *
   * @param   {boolean} isStartup
   *          スタートアップイベントか
   * @param   {number} reason
   *          スタートアップの理由
   */
  load: function(isStartup, reason) {
  },
  
  /**
   * ウィンドウからアンロードする
   *
   * @param   {boolean} isShutdown
   *          シャットダウンイベントか
   * @param   {number} reason
   *          シャットダウンの理由
   */
  unload: function(isShutdown, reason) {
  },
  
  /* ==== private ==== */
  
  _window: null,   /** 対象のウィンドウ
                    *  @type {nsIDOMWindow} */
  
  /**
   * getElementById の省略
   *
   * @param   {string} id
   *          要素の ID
   * @returns {nsIDOMElement}
   *          id に対応する要素
   *          見付からなければ null
   */
  el: function(id) {
    return this._window.document.getElementById(id);
  }
};
